@echo off

C:
cd \Firebird

SET errorlevel=
SET IPHOST_DATADIR=C:\ProgramData\IPHost Network Monitor\data
SET FIREBIRD_BIN=C:\Program Files (x86)\Firebird\Firebird_2_5\bin
SET BACKUP_DIR=D:\Backup\IPHost
SET ISC_USER=SYSDBA
SET ISC_PASSWORD=masterkey

rem Deleting files, if already exist
del /q /f nms-test.fdb nms-test.gbak nms.gbak >nul 2>&1

rem Copy nms.gbak file, if present
if exist "%IPHOST_DATADIR%\nms.gbak" (
    copy /Y "%IPHOST_DATADIR%\nms.gbak" "%CD%\nms-unchecked.gbak" >nul 2>&1
) else (
    echo Database hot backup does not exist
    exit 1
)

rem File hasn't copied, aborting
if not exist "%CD%\nms-unchecked.gbak" (
    echo Hot backup could not be copied for processing
    exit 2
)

rem Attempt to get FDB database file from its hot backup
"%FIREBIRD_BIN%\nbackup.exe" -r "%CD%\nms-test.fdb" "%CD%\nms-unchecked.gbak" >nul 2>&1
if errorlevel 1 (
    echo Cannot restore database from hot backup
    del /q /f nms-test.fdb nms-unchecked.gbak >nul 2>&1
    exit 3
)

rem Attempt to make regular backup from this FDB file, thus checking for errors
"%FIREBIRD_BIN%\gbak.exe" -SE localhost/3055:service_mgr -b "%CD%\nms-test.fdb" "%CD%\nms-test.gbak" >nul 2>&1
if errorlevel 1 (
    echo Cannot create backup file from database
    del /q /f nms-test.fdb nms-test.gbak nms-unchecked.gbak >nul 2>&1
    exit 4
)

echo 0
rem Uncomment two lines below to enable backups
rem SET DOW=%date:~0,3%
rem copy /Y "%CD%\nms-test.gbak" "%BACKUP_DIR%\nms-checked-%DOW%.gbak" >nul 2>&1
del /q /f nms-test.fdb nms-test.gbak nms-unchecked.gbak >nul 2>&1
exit 0
